-- { dg-do run }
-- { dg-options "-O2" }
-- This test should only be run on big endian targets.
with Interfaces; use interfaces;
with Ada.Unchecked_Conversion;
With System; use System;

procedure packed_2 is
  type T is array (1..4) of Boolean; pragma Pack(T);

  type A is record field : T; end record;
  type B is record field : T; end record;
  for B use record field at 0 range 0..5; end record;

  function A_To_Byte is new Ada.Unchecked_Conversion (A, Unsigned_8);
  function B_To_Byte is new Ada.Unchecked_Conversion (B, Unsigned_8);

  procedure TtoA (qt : in T; qa : out A) is begin qa.field := qt; end;

  procedure TtoB (qt : in T; qb : out B) is begin qb.field := qt; end;

  my_t : T := (true, true, true, false);
  my_a : A;
  my_b : B;

begin
  TtoA (my_t, my_a);
  TtoB (my_t, my_b);
  
  if System.Default_Bit_Order = System.HIGH_ORDER_FIRST
    and Shift_Right(A_To_Byte(my_a), 4) /= 14
    and Shift_Right(B_To_Byte(my_b), 4) /= 14 then
    raise Program_Error;
  end if;
end;
